<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: melon Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('namespacemelon.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#nested-classes">Classes</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle"><div class="title">melon Namespace Reference</div></div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="namespaces" name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespacemelon_1_1kernel" id="r_namespacemelon_1_1kernel"><td class="memItemLeft" align="right" valign="top">namespace &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacemelon_1_1kernel.html">kernel</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmelon_1_1_ann_data.html">AnnData</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">struct containing all information regarding the structure of a feedforward neural network  <a href="structmelon_1_1_ann_data.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmelon_1_1_ann_normalization_parameters.html">AnnNormalizationParameters</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">struct containing the parameters required for input normalization and output denormalization of a feedforward neural network  <a href="structmelon_1_1_ann_normalization_parameters.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_ann_parser.html">AnnParser</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class implements an abstract parent class for ANN file parser.  <a href="classmelon_1_1_ann_parser.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_ann_parser_csv.html">AnnParserCsv</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class implements an specialization of the <a class="el" href="classmelon_1_1_ann_parser.html" title="This class implements an abstract parent class for ANN file parser.">AnnParser</a> for csv files.  <a href="classmelon_1_1_ann_parser_csv.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_ann_parser_factory.html">AnnParserFactory</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class is a factory class for creating child instances of <a class="el" href="classmelon_1_1_ann_parser.html" title="This class implements an abstract parent class for ANN file parser.">AnnParser</a>.  <a href="classmelon_1_1_ann_parser_factory.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_ann_parser_xml.html">AnnParserXml</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class implements an specialization of the <a class="el" href="classmelon_1_1_ann_parser.html" title="This class implements an abstract parent class for ANN file parser.">AnnParser</a> for xml files.  <a href="classmelon_1_1_ann_parser_xml.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmelon_1_1_ann_structure.html">AnnStructure</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">struct containing all information regarding the structure of a feedforward neural network  <a href="structmelon_1_1_ann_structure.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmelon_1_1_ann_weights.html">AnnWeights</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">struct containing the different weights of a feedforward neural network  <a href="structmelon_1_1_ann_weights.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_feed_forward_net.html">FeedForwardNet</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class represents a feed foward artificial network to be used in the MAiNGO solver.  <a href="classmelon_1_1_feed_forward_net.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_gaussian_process.html">GaussianProcess</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class represents a Gaussian process, to be used in the MAiNGO solver.  <a href="classmelon_1_1_gaussian_process.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmelon_1_1_g_p_data.html">GPData</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">struct containing all information regarding the Gaussian process  <a href="structmelon_1_1_g_p_data.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_gp_parser.html">GpParser</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class implements a Gaussian process file parser.  <a href="classmelon_1_1_gp_parser.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_gp_parser_factory.html">GpParserFactory</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class is a factory class for creating child instances of <a class="el" href="classmelon_1_1_gp_parser.html" title="This class implements a Gaussian process file parser.">GpParser</a>.  <a href="classmelon_1_1_gp_parser_factory.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_identity_scaler.html">IdentityScaler</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class implementing an identity scaling algorithm.  <a href="classmelon_1_1_identity_scaler.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_melon_model.html">MelonModel</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_min_max_scaler.html">MinMaxScaler</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class implementing a MinMax-Scaling algorithm.  <a href="classmelon_1_1_min_max_scaler.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_model_parser.html">ModelParser</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class is a abstract parent class for model parser implemented in the MeLOn library.  <a href="classmelon_1_1_model_parser.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_model_parser_factory.html">ModelParserFactory</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class is a abstract parent class for model parser factories implemented in the MeLOn library.  <a href="classmelon_1_1_model_parser_factory.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_mulfil_gp.html">MulfilGp</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class that represents a multifidelity Gaussian process, to be used in the MAiNGO solver.  <a href="classmelon_1_1_mulfil_gp.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmelon_1_1_mulfil_gp_data.html">MulfilGpData</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_mulfil_gp_parser.html">MulfilGpParser</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class that implements a multifidelity Gaussian process file parser.  <a href="classmelon_1_1_mulfil_gp_parser.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_mulfil_gp_parser_factory.html">MulfilGpParserFactory</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class that implements a factory for creating child instances of <a class="el" href="classmelon_1_1_mulfil_gp_parser.html" title="Class that implements a multifidelity Gaussian process file parser.">MulfilGpParser</a>.  <a href="classmelon_1_1_mulfil_gp_parser_factory.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_scaler.html">Scaler</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Abstract class defining scaling algorithm.  <a href="classmelon_1_1_scaler.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmelon_1_1_scaler_data.html">ScalerData</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Base struct from which data structs of different scalers can be derived.  <a href="structmelon_1_1_scaler_data.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_scaler_factory.html">ScalerFactory</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class is a factory class for creating child instances of <a class="el" href="classmelon_1_1_scaler.html" title="Abstract class defining scaling algorithm.">Scaler</a>.  <a href="classmelon_1_1_scaler_factory.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_standard_scaler.html">StandardScaler</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class implementing a Standard-Scaling algorithm.  <a href="classmelon_1_1_standard_scaler.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_support_vector_machine.html">SupportVectorMachine</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class defining support vector machine to be used in the MAiNGO solver.  <a href="classmelon_1_1_support_vector_machine.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_support_vector_machine_one_class.html">SupportVectorMachineOneClass</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class defining support vector machine for one class classification to be used in the MAiNGO solver.  <a href="classmelon_1_1_support_vector_machine_one_class.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_support_vector_regression.html">SupportVectorRegression</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Class defining support vector machine for regression to be used in the MAiNGO solver.  <a href="classmelon_1_1_support_vector_regression.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structmelon_1_1_svm_data.html">SvmData</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">Struct containing all information regarding the support vector machine.  <a href="structmelon_1_1_svm_data.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_svm_parser.html">SvmParser</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class implements a support vector machine file parser.  <a href="classmelon_1_1_svm_parser.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classmelon_1_1_svm_parser_factory.html">SvmParserFactory</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This class is a factory class for creating child instances of <a class="el" href="classmelon_1_1_svm_parser.html" title="This class implements a support vector machine file parser.">SvmParser</a>.  <a href="classmelon_1_1_svm_parser_factory.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:a4304be33fc99f22bd328db5774394531" id="r_a4304be33fc99f22bd328db5774394531"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a4304be33fc99f22bd328db5774394531">MODEL_FILE_TYPE</a> { <a class="el" href="#a4304be33fc99f22bd328db5774394531a6a25a8815b9ce41cb44aec7974135a23">CSV</a> = 0
, <a class="el" href="#a4304be33fc99f22bd328db5774394531a85425286917a906087af8aa4f28b99e7">XML</a>
, <a class="el" href="#a4304be33fc99f22bd328db5774394531aaa1153b20d42a497e239ee88cc90fe6d">JSON</a>
 }</td></tr>
<tr class="memdesc:a4304be33fc99f22bd328db5774394531"><td class="mdescLeft">&#160;</td><td class="mdescRight">Enum for representing the parsable filetypes.  <a href="#a4304be33fc99f22bd328db5774394531">More...</a><br /></td></tr>
<tr class="separator:a4304be33fc99f22bd328db5774394531"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ee65995944832d7b450202201d45c11" id="r_a7ee65995944832d7b450202201d45c11"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a7ee65995944832d7b450202201d45c11">SCALER_TYPE</a> { <a class="el" href="#a7ee65995944832d7b450202201d45c11afaeaa7edb255915742a7160e41431ac3">IDENTITY</a> = 0
, <a class="el" href="#a7ee65995944832d7b450202201d45c11ac7872fa543809084c52b6271d3fdfebf">MINMAX</a>
, <a class="el" href="#a7ee65995944832d7b450202201d45c11acdd23303789346092329efb21bb94a62">STANDARD</a>
 }</td></tr>
<tr class="memdesc:a7ee65995944832d7b450202201d45c11"><td class="mdescLeft">&#160;</td><td class="mdescRight">Enum for representing the available types of scalers.  <a href="#a7ee65995944832d7b450202201d45c11">More...</a><br /></td></tr>
<tr class="separator:a7ee65995944832d7b450202201d45c11"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7c96133788161408370e83766fc229ce" id="r_a7c96133788161408370e83766fc229ce"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a7c96133788161408370e83766fc229ce">SCALER_PARAMETER</a> { <br />
&#160;&#160;<a class="el" href="#a7c96133788161408370e83766fc229ceaf78372f3432f97adeaeb2af268197309">LOWER_BOUNDS</a> = 0
, <a class="el" href="#a7c96133788161408370e83766fc229ceac08c5be55fca3df3d17b9195c771513b">UPPER_BOUNDS</a>
, <a class="el" href="#a7c96133788161408370e83766fc229ceab0822e223d8cf003bdb0b83f0134e6e4">STD_DEV</a>
, <a class="el" href="#a7c96133788161408370e83766fc229cea2ad43cbc6545d4304492db86d53638db">MEAN</a>
, <br />
&#160;&#160;<a class="el" href="#a7c96133788161408370e83766fc229cea70d9219e0e27a9c129ebfdb80b6b907f">SCALED_LOWER_BOUNDS</a>
, <a class="el" href="#a7c96133788161408370e83766fc229cea92a33be48e968102397691173990fe32">SCALED_UPPER_BOUNDS</a>
<br />
 }</td></tr>
<tr class="separator:a7c96133788161408370e83766fc229ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a48f12885945641a41597e6668940dc73" id="r_a48f12885945641a41597e6668940dc73"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a48f12885945641a41597e6668940dc73">ACTIVATION_FUNCTION</a> { <a class="el" href="#a48f12885945641a41597e6668940dc73a2f195b9787f598a7ee661a881c474e3b">PURE_LIN</a> = 0
, <a class="el" href="#a48f12885945641a41597e6668940dc73ad3d7d3b5435748e6d590a93d042de6c2">TANH</a>
, <a class="el" href="#a48f12885945641a41597e6668940dc73acb18be48f9330d10bfd46e4046f09d3c">RELU</a>
, <a class="el" href="#a48f12885945641a41597e6668940dc73a48a94bc178c62695a3d5142cb8b984ed">RELU6</a>
 }</td></tr>
<tr class="memdesc:a48f12885945641a41597e6668940dc73"><td class="mdescLeft">&#160;</td><td class="mdescRight">Enum for representing the available types of scaler parameters.  <a href="#a48f12885945641a41597e6668940dc73">More...</a><br /></td></tr>
<tr class="separator:a48f12885945641a41597e6668940dc73"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8022b4f904d4418a296e665306c3ff45" id="r_a8022b4f904d4418a296e665306c3ff45"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#a8022b4f904d4418a296e665306c3ff45">TANH_REFORMULATION</a> { <br />
&#160;&#160;<a class="el" href="#a8022b4f904d4418a296e665306c3ff45a0421f11571e68cf83bd0e9098c4a9b06">TANH_REF_0</a> = 0
, <a class="el" href="#a8022b4f904d4418a296e665306c3ff45a4bc63b72e39fc9afbb0180ce9696ae44">TANH_REF1</a>
, <a class="el" href="#a8022b4f904d4418a296e665306c3ff45aa92da5b44334a4d1b46e21b3e0d04e42">TANH_REF2</a>
, <a class="el" href="#a8022b4f904d4418a296e665306c3ff45aa409ddee207d203ecccf9ed6fc1c008e">TANH_REF3</a>
, <br />
&#160;&#160;<a class="el" href="#a8022b4f904d4418a296e665306c3ff45a34a691a87b4d07bbdda82aa924ce94b0">TANH_REF4</a>
<br />
 }</td></tr>
<tr class="memdesc:a8022b4f904d4418a296e665306c3ff45"><td class="mdescLeft">&#160;</td><td class="mdescRight">Enum for representing the different reformulations for the tanh activation function.  <a href="#a8022b4f904d4418a296e665306c3ff45">More...</a><br /></td></tr>
<tr class="separator:a8022b4f904d4418a296e665306c3ff45"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9d1641da9e08a0d25d8d6cefcc92887" id="r_ae9d1641da9e08a0d25d8d6cefcc92887"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="#ae9d1641da9e08a0d25d8d6cefcc92887">KERNEL_FUNCTION</a> { <a class="el" href="#ae9d1641da9e08a0d25d8d6cefcc92887ae0c0181a2948647ea58c0940cce1b47e">RBF</a>
 }</td></tr>
<tr class="memdesc:ae9d1641da9e08a0d25d8d6cefcc92887"><td class="mdescLeft">&#160;</td><td class="mdescRight">enum for representing different kernel functions  <a href="#ae9d1641da9e08a0d25d8d6cefcc92887">More...</a><br /></td></tr>
<tr class="separator:ae9d1641da9e08a0d25d8d6cefcc92887"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a80e855bf708cd67182f551d005dea25e" id="r_a80e855bf708cd67182f551d005dea25e"><td class="memTemplParams" colspan="2">template&lt;typename T , typename U &gt; </td></tr>
<tr class="memitem:a80e855bf708cd67182f551d005dea25e"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#a80e855bf708cd67182f551d005dea25e">operator+</a> (const std::vector&lt; T &gt; &amp;v1, const std::vector&lt; U &gt; &amp;v2)</td></tr>
<tr class="memdesc:a80e855bf708cd67182f551d005dea25e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing adding vectors.  <br /></td></tr>
<tr class="separator:a80e855bf708cd67182f551d005dea25e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2653a81de37c679fc48d8303b202614" id="r_ab2653a81de37c679fc48d8303b202614"><td class="memTemplParams" colspan="2">template&lt;typename T , typename U &gt; </td></tr>
<tr class="memitem:ab2653a81de37c679fc48d8303b202614"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#ab2653a81de37c679fc48d8303b202614">operator+</a> (const std::vector&lt; T &gt; &amp;v, const U s)</td></tr>
<tr class="memdesc:ab2653a81de37c679fc48d8303b202614"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing adding scalars to vectors.  <br /></td></tr>
<tr class="separator:ab2653a81de37c679fc48d8303b202614"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b23af0670582490d233e2cfa02bbf7a" id="r_a2b23af0670582490d233e2cfa02bbf7a"><td class="memTemplParams" colspan="2">template&lt;typename T , typename U &gt; </td></tr>
<tr class="memitem:a2b23af0670582490d233e2cfa02bbf7a"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#a2b23af0670582490d233e2cfa02bbf7a">operator-</a> (std::vector&lt; T &gt; &amp;v1, std::vector&lt; U &gt; &amp;v2)</td></tr>
<tr class="memdesc:a2b23af0670582490d233e2cfa02bbf7a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing substracting vectors.  <br /></td></tr>
<tr class="separator:a2b23af0670582490d233e2cfa02bbf7a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7bdd489b771e3b35186e3a89fc4520ad" id="r_a7bdd489b771e3b35186e3a89fc4520ad"><td class="memTemplParams" colspan="2">template&lt;typename T , typename U &gt; </td></tr>
<tr class="memitem:a7bdd489b771e3b35186e3a89fc4520ad"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#a7bdd489b771e3b35186e3a89fc4520ad">operator-</a> (const std::vector&lt; T &gt; &amp;v, const U s)</td></tr>
<tr class="memdesc:a7bdd489b771e3b35186e3a89fc4520ad"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing substracting scalars from vectors.  <br /></td></tr>
<tr class="separator:a7bdd489b771e3b35186e3a89fc4520ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a01c6cf5e8fc7f903c966ed77d3582789" id="r_a01c6cf5e8fc7f903c966ed77d3582789"><td class="memTemplParams" colspan="2">template&lt;typename T , typename U &gt; </td></tr>
<tr class="memitem:a01c6cf5e8fc7f903c966ed77d3582789"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#a01c6cf5e8fc7f903c966ed77d3582789">operator*</a> (const T &amp;s, const std::vector&lt; U &gt; &amp;v)</td></tr>
<tr class="memdesc:a01c6cf5e8fc7f903c966ed77d3582789"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing the calulation of a vector scalar product.  <br /></td></tr>
<tr class="separator:a01c6cf5e8fc7f903c966ed77d3582789"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae6d2a726febc6962b2b4b60fe1bb472" id="r_aae6d2a726febc6962b2b4b60fe1bb472"><td class="memTemplParams" colspan="2">template&lt;typename T , typename U &gt; </td></tr>
<tr class="memitem:aae6d2a726febc6962b2b4b60fe1bb472"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#aae6d2a726febc6962b2b4b60fe1bb472">operator*</a> (const std::vector&lt; T &gt; &amp;v, const U &amp;s)</td></tr>
<tr class="memdesc:aae6d2a726febc6962b2b4b60fe1bb472"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing the calulation of a vector scalar product.  <br /></td></tr>
<tr class="separator:aae6d2a726febc6962b2b4b60fe1bb472"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a24bae557d935851e04ec91570cdf6b46" id="r_a24bae557d935851e04ec91570cdf6b46"><td class="memTemplParams" colspan="2">template&lt;typename T , typename U &gt; </td></tr>
<tr class="memitem:a24bae557d935851e04ec91570cdf6b46"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#a24bae557d935851e04ec91570cdf6b46">operator/</a> (const std::vector&lt; T &gt; &amp;v, const U &amp;s)</td></tr>
<tr class="memdesc:a24bae557d935851e04ec91570cdf6b46"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing the calulation of a vector scalar division.  <br /></td></tr>
<tr class="separator:a24bae557d935851e04ec91570cdf6b46"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9cb84438576c7ac32cbe6f10b3e9e2b3" id="r_a9cb84438576c7ac32cbe6f10b3e9e2b3"><td class="memTemplParams" colspan="2">template&lt;typename T , typename U &gt; </td></tr>
<tr class="memitem:a9cb84438576c7ac32cbe6f10b3e9e2b3"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#a9cb84438576c7ac32cbe6f10b3e9e2b3">dot_product</a> (const std::vector&lt; T &gt; &amp;v1, const std::vector&lt; U &gt; &amp;v2)</td></tr>
<tr class="memdesc:a9cb84438576c7ac32cbe6f10b3e9e2b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing the calulation of dot product of two vectors.  <br /></td></tr>
<tr class="separator:a9cb84438576c7ac32cbe6f10b3e9e2b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adfc1c64d377bc9a21eea10b08a2812bd" id="r_adfc1c64d377bc9a21eea10b08a2812bd"><td class="memTemplParams" colspan="2">template&lt;typename T , typename U &gt; </td></tr>
<tr class="memitem:adfc1c64d377bc9a21eea10b08a2812bd"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#adfc1c64d377bc9a21eea10b08a2812bd">operator*</a> (const std::vector&lt; std::vector&lt; T &gt; &gt; &amp;m, const std::vector&lt; U &gt; &amp;v)</td></tr>
<tr class="memdesc:adfc1c64d377bc9a21eea10b08a2812bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing the calulation of a matrix vector product.  <br /></td></tr>
<tr class="separator:adfc1c64d377bc9a21eea10b08a2812bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a40328bd6fab65711cf52ef704a727e63" id="r_a40328bd6fab65711cf52ef704a727e63"><td class="memTemplParams" colspan="2">template&lt;typename T , typename U &gt; </td></tr>
<tr class="memitem:a40328bd6fab65711cf52ef704a727e63"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#a40328bd6fab65711cf52ef704a727e63">operator*</a> (const std::vector&lt; std::vector&lt; T &gt; &gt; &amp;m1, const std::vector&lt; std::vector&lt; U &gt; &gt; &amp;m2)</td></tr>
<tr class="memdesc:a40328bd6fab65711cf52ef704a727e63"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing the calulation of a matrix matrix product.  <br /></td></tr>
<tr class="separator:a40328bd6fab65711cf52ef704a727e63"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa014086872bff2237b6ffa78096b593f" id="r_aa014086872bff2237b6ffa78096b593f"><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr class="memitem:aa014086872bff2237b6ffa78096b593f"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#aa014086872bff2237b6ffa78096b593f">transpose</a> (const std::vector&lt; std::vector&lt; T &gt; &gt; &amp;m)</td></tr>
<tr class="memdesc:aa014086872bff2237b6ffa78096b593f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing to transpose a matrix.  <br /></td></tr>
<tr class="separator:aa014086872bff2237b6ffa78096b593f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16df369db8ed77a096d88bcac6c37487" id="r_a16df369db8ed77a096d88bcac6c37487"><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr class="memitem:a16df369db8ed77a096d88bcac6c37487"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="#a16df369db8ed77a096d88bcac6c37487">diag</a> (const std::vector&lt; std::vector&lt; T &gt; &gt; &amp;m)</td></tr>
<tr class="memdesc:a16df369db8ed77a096d88bcac6c37487"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overloaded operator for vector class allowing to obtain a matrix diagonal.  <br /></td></tr>
<tr class="separator:a16df369db8ed77a096d88bcac6c37487"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Enumeration Type Documentation</h2>
<a id="a48f12885945641a41597e6668940dc73" name="a48f12885945641a41597e6668940dc73"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a48f12885945641a41597e6668940dc73">&#9670;&#160;</a></span>ACTIVATION_FUNCTION</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="#a48f12885945641a41597e6668940dc73">melon::ACTIVATION_FUNCTION</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Enum for representing the available types of scaler parameters. </p>
<p>Enum for representing the available types of activation functions. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a48f12885945641a41597e6668940dc73a2f195b9787f598a7ee661a881c474e3b" name="a48f12885945641a41597e6668940dc73a2f195b9787f598a7ee661a881c474e3b"></a>PURE_LIN&#160;</td><td class="fielddoc"><p>no activation function (y=x) </p>
</td></tr>
<tr><td class="fieldname"><a id="a48f12885945641a41597e6668940dc73ad3d7d3b5435748e6d590a93d042de6c2" name="a48f12885945641a41597e6668940dc73ad3d7d3b5435748e6d590a93d042de6c2"></a>TANH&#160;</td><td class="fielddoc"><p>tanh </p>
</td></tr>
<tr><td class="fieldname"><a id="a48f12885945641a41597e6668940dc73acb18be48f9330d10bfd46e4046f09d3c" name="a48f12885945641a41597e6668940dc73acb18be48f9330d10bfd46e4046f09d3c"></a>RELU&#160;</td><td class="fielddoc"><p>ReLU </p>
</td></tr>
<tr><td class="fieldname"><a id="a48f12885945641a41597e6668940dc73a48a94bc178c62695a3d5142cb8b984ed" name="a48f12885945641a41597e6668940dc73a48a94bc178c62695a3d5142cb8b984ed"></a>RELU6&#160;</td><td class="fielddoc"><p>ReLU that is bounded to a maximal value of 6 </p>
</td></tr>
</table>

</div>
</div>
<a id="ae9d1641da9e08a0d25d8d6cefcc92887" name="ae9d1641da9e08a0d25d8d6cefcc92887"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae9d1641da9e08a0d25d8d6cefcc92887">&#9670;&#160;</a></span>KERNEL_FUNCTION</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="#ae9d1641da9e08a0d25d8d6cefcc92887">melon::KERNEL_FUNCTION</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>enum for representing different kernel functions </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="ae9d1641da9e08a0d25d8d6cefcc92887ae0c0181a2948647ea58c0940cce1b47e" name="ae9d1641da9e08a0d25d8d6cefcc92887ae0c0181a2948647ea58c0940cce1b47e"></a>RBF&#160;</td><td class="fielddoc"><p>Radial Basis Kernel </p>
</td></tr>
</table>

</div>
</div>
<a id="a4304be33fc99f22bd328db5774394531" name="a4304be33fc99f22bd328db5774394531"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4304be33fc99f22bd328db5774394531">&#9670;&#160;</a></span>MODEL_FILE_TYPE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="#a4304be33fc99f22bd328db5774394531">melon::MODEL_FILE_TYPE</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Enum for representing the parsable filetypes. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a4304be33fc99f22bd328db5774394531a6a25a8815b9ce41cb44aec7974135a23" name="a4304be33fc99f22bd328db5774394531a6a25a8815b9ce41cb44aec7974135a23"></a>CSV&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="a4304be33fc99f22bd328db5774394531a85425286917a906087af8aa4f28b99e7" name="a4304be33fc99f22bd328db5774394531a85425286917a906087af8aa4f28b99e7"></a>XML&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="a4304be33fc99f22bd328db5774394531aaa1153b20d42a497e239ee88cc90fe6d" name="a4304be33fc99f22bd328db5774394531aaa1153b20d42a497e239ee88cc90fe6d"></a>JSON&#160;</td><td class="fielddoc"></td></tr>
</table>

</div>
</div>
<a id="a7c96133788161408370e83766fc229ce" name="a7c96133788161408370e83766fc229ce"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7c96133788161408370e83766fc229ce">&#9670;&#160;</a></span>SCALER_PARAMETER</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="#a7c96133788161408370e83766fc229ce">melon::SCALER_PARAMETER</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a7c96133788161408370e83766fc229ceaf78372f3432f97adeaeb2af268197309" name="a7c96133788161408370e83766fc229ceaf78372f3432f97adeaeb2af268197309"></a>LOWER_BOUNDS&#160;</td><td class="fielddoc"><p>lower bounds of training data </p>
</td></tr>
<tr><td class="fieldname"><a id="a7c96133788161408370e83766fc229ceac08c5be55fca3df3d17b9195c771513b" name="a7c96133788161408370e83766fc229ceac08c5be55fca3df3d17b9195c771513b"></a>UPPER_BOUNDS&#160;</td><td class="fielddoc"><p>upper bounds of training data </p>
</td></tr>
<tr><td class="fieldname"><a id="a7c96133788161408370e83766fc229ceab0822e223d8cf003bdb0b83f0134e6e4" name="a7c96133788161408370e83766fc229ceab0822e223d8cf003bdb0b83f0134e6e4"></a>STD_DEV&#160;</td><td class="fielddoc"><p>standard derivation of training data </p>
</td></tr>
<tr><td class="fieldname"><a id="a7c96133788161408370e83766fc229cea2ad43cbc6545d4304492db86d53638db" name="a7c96133788161408370e83766fc229cea2ad43cbc6545d4304492db86d53638db"></a>MEAN&#160;</td><td class="fielddoc"><p>mean of training data </p>
</td></tr>
<tr><td class="fieldname"><a id="a7c96133788161408370e83766fc229cea70d9219e0e27a9c129ebfdb80b6b907f" name="a7c96133788161408370e83766fc229cea70d9219e0e27a9c129ebfdb80b6b907f"></a>SCALED_LOWER_BOUNDS&#160;</td><td class="fielddoc"><p>lower bound of scaled data </p>
</td></tr>
<tr><td class="fieldname"><a id="a7c96133788161408370e83766fc229cea92a33be48e968102397691173990fe32" name="a7c96133788161408370e83766fc229cea92a33be48e968102397691173990fe32"></a>SCALED_UPPER_BOUNDS&#160;</td><td class="fielddoc"><p>upper bound of scaled data </p>
</td></tr>
</table>

</div>
</div>
<a id="a7ee65995944832d7b450202201d45c11" name="a7ee65995944832d7b450202201d45c11"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7ee65995944832d7b450202201d45c11">&#9670;&#160;</a></span>SCALER_TYPE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="#a7ee65995944832d7b450202201d45c11">melon::SCALER_TYPE</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Enum for representing the available types of scalers. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a7ee65995944832d7b450202201d45c11afaeaa7edb255915742a7160e41431ac3" name="a7ee65995944832d7b450202201d45c11afaeaa7edb255915742a7160e41431ac3"></a>IDENTITY&#160;</td><td class="fielddoc"><p>identity scaler </p>
</td></tr>
<tr><td class="fieldname"><a id="a7ee65995944832d7b450202201d45c11ac7872fa543809084c52b6271d3fdfebf" name="a7ee65995944832d7b450202201d45c11ac7872fa543809084c52b6271d3fdfebf"></a>MINMAX&#160;</td><td class="fielddoc"><p>MinMax scaler </p>
</td></tr>
<tr><td class="fieldname"><a id="a7ee65995944832d7b450202201d45c11acdd23303789346092329efb21bb94a62" name="a7ee65995944832d7b450202201d45c11acdd23303789346092329efb21bb94a62"></a>STANDARD&#160;</td><td class="fielddoc"><p>standard scaler </p>
</td></tr>
</table>

</div>
</div>
<a id="a8022b4f904d4418a296e665306c3ff45" name="a8022b4f904d4418a296e665306c3ff45"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8022b4f904d4418a296e665306c3ff45">&#9670;&#160;</a></span>TANH_REFORMULATION</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="#a8022b4f904d4418a296e665306c3ff45">melon::TANH_REFORMULATION</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Enum for representing the different reformulations for the tanh activation function. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a8022b4f904d4418a296e665306c3ff45a0421f11571e68cf83bd0e9098c4a9b06" name="a8022b4f904d4418a296e665306c3ff45a0421f11571e68cf83bd0e9098c4a9b06"></a>TANH_REF_0&#160;</td><td class="fielddoc"><p>Standard tanh </p>
</td></tr>
<tr><td class="fieldname"><a id="a8022b4f904d4418a296e665306c3ff45a4bc63b72e39fc9afbb0180ce9696ae44" name="a8022b4f904d4418a296e665306c3ff45a4bc63b72e39fc9afbb0180ce9696ae44"></a>TANH_REF1&#160;</td><td class="fielddoc"><p>tanh(x) = exp(x) - exp(-1 * x)) / (exp(x) + exp(-1 * x) </p>
</td></tr>
<tr><td class="fieldname"><a id="a8022b4f904d4418a296e665306c3ff45aa92da5b44334a4d1b46e21b3e0d04e42" name="a8022b4f904d4418a296e665306c3ff45aa92da5b44334a4d1b46e21b3e0d04e42"></a>TANH_REF2&#160;</td><td class="fielddoc"><p>tanh(x) = (exp(2 * x) - 1) / (exp(2 * x) + 1) </p>
</td></tr>
<tr><td class="fieldname"><a id="a8022b4f904d4418a296e665306c3ff45aa409ddee207d203ecccf9ed6fc1c008e" name="a8022b4f904d4418a296e665306c3ff45aa409ddee207d203ecccf9ed6fc1c008e"></a>TANH_REF3&#160;</td><td class="fielddoc"><p>tanh(x) = 1 - 2 / (1 + exp(2 * x)) </p>
</td></tr>
<tr><td class="fieldname"><a id="a8022b4f904d4418a296e665306c3ff45a34a691a87b4d07bbdda82aa924ce94b0" name="a8022b4f904d4418a296e665306c3ff45a34a691a87b4d07bbdda82aa924ce94b0"></a>TANH_REF4&#160;</td><td class="fielddoc"><p>tanh(x) = (1 - exp(-2 * x)) / (1 + exp(-2 * x)) </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a16df369db8ed77a096d88bcac6c37487" name="a16df369db8ed77a096d88bcac6c37487"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a16df369db8ed77a096d88bcac6c37487">&#9670;&#160;</a></span>diag()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::diag </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; std::vector&lt; T &gt; &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>m</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing to obtain a matrix diagonal. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">m</td><td>is the matrix of which the diagonal is obtained</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a result vector res = diag(m) </dd></dl>

</div>
</div>
<a id="a9cb84438576c7ac32cbe6f10b3e9e2b3" name="a9cb84438576c7ac32cbe6f10b3e9e2b3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9cb84438576c7ac32cbe6f10b3e9e2b3">&#9670;&#160;</a></span>dot_product()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::dot_product </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; T &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v1</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; U &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v2</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing the calulation of dot product of two vectors. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">v1</td><td>is the first vector</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">v2</td><td>is the second vector</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a result vector res = v1^T * v2 </dd></dl>

</div>
</div>
<a id="adfc1c64d377bc9a21eea10b08a2812bd" name="adfc1c64d377bc9a21eea10b08a2812bd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adfc1c64d377bc9a21eea10b08a2812bd">&#9670;&#160;</a></span>operator*() <span class="overload">[1/4]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::operator* </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; std::vector&lt; T &gt; &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>m</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; U &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing the calulation of a matrix vector product. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">m</td><td>is the matrix to be multiplied</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">v</td><td>ist the factor vector</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a result vector res = m*v </dd></dl>

</div>
</div>
<a id="a40328bd6fab65711cf52ef704a727e63" name="a40328bd6fab65711cf52ef704a727e63"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a40328bd6fab65711cf52ef704a727e63">&#9670;&#160;</a></span>operator*() <span class="overload">[2/4]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::operator* </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; std::vector&lt; T &gt; &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>m1</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; std::vector&lt; U &gt; &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>m2</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing the calulation of a matrix matrix product. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">m1</td><td>is the first matrix factor</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">m2</td><td>is the second matrix factor</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a result vector res = m*m </dd></dl>

</div>
</div>
<a id="aae6d2a726febc6962b2b4b60fe1bb472" name="aae6d2a726febc6962b2b4b60fe1bb472"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aae6d2a726febc6962b2b4b60fe1bb472">&#9670;&#160;</a></span>operator*() <span class="overload">[3/4]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::operator* </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; T &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const U &amp;</td>          <td class="paramname"><span class="paramname"><em>s</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing the calulation of a vector scalar product. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">v</td><td>is the factor vector</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">s</td><td>is the scalar factor</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a result vector res = v*s </dd></dl>

</div>
</div>
<a id="a01c6cf5e8fc7f903c966ed77d3582789" name="a01c6cf5e8fc7f903c966ed77d3582789"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a01c6cf5e8fc7f903c966ed77d3582789">&#9670;&#160;</a></span>operator*() <span class="overload">[4/4]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::operator* </td>
          <td>(</td>
          <td class="paramtype">const T &amp;</td>          <td class="paramname"><span class="paramname"><em>s</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; U &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing the calulation of a vector scalar product. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">s</td><td>is the scalar factor</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">v</td><td>is the factor vector</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a result vector res = s*v </dd></dl>

</div>
</div>
<a id="ab2653a81de37c679fc48d8303b202614" name="ab2653a81de37c679fc48d8303b202614"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab2653a81de37c679fc48d8303b202614">&#9670;&#160;</a></span>operator+() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::operator+ </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; T &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const U</td>          <td class="paramname"><span class="paramname"><em>s</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing adding scalars to vectors. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">v</td><td>is the summand vector</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">s</td><td>is the summand scalar</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a vector res = v1 + v2 </dd></dl>

</div>
</div>
<a id="a80e855bf708cd67182f551d005dea25e" name="a80e855bf708cd67182f551d005dea25e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a80e855bf708cd67182f551d005dea25e">&#9670;&#160;</a></span>operator+() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::operator+ </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; T &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v1</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::vector&lt; U &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v2</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing adding vectors. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">v1</td><td>is the first summand vector</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">v2</td><td>is the second summand vector</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a vector res = v1 + v2 </dd></dl>

</div>
</div>
<a id="a7bdd489b771e3b35186e3a89fc4520ad" name="a7bdd489b771e3b35186e3a89fc4520ad"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7bdd489b771e3b35186e3a89fc4520ad">&#9670;&#160;</a></span>operator-() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::operator- </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; T &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const U</td>          <td class="paramname"><span class="paramname"><em>s</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing substracting scalars from vectors. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">v</td><td>is the minuend vector</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">s</td><td>is the subtrahend scalar</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a result vector res = v1 - v2 </dd></dl>

</div>
</div>
<a id="a2b23af0670582490d233e2cfa02bbf7a" name="a2b23af0670582490d233e2cfa02bbf7a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2b23af0670582490d233e2cfa02bbf7a">&#9670;&#160;</a></span>operator-() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::operator- </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; T &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v1</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; U &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v2</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing substracting vectors. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">v1</td><td>is the minuend vector</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">v2</td><td>is the subtrahend vector</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a result vector res = v1 - v2 </dd></dl>

</div>
</div>
<a id="a24bae557d935851e04ec91570cdf6b46" name="a24bae557d935851e04ec91570cdf6b46"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a24bae557d935851e04ec91570cdf6b46">&#9670;&#160;</a></span>operator/()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename U &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::operator/ </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; T &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>v</em>, </span></td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const U &amp;</td>          <td class="paramname"><span class="paramname"><em>s</em></span>&#160;)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing the calulation of a vector scalar division. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">v</td><td>is the dividend vector</td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">s</td><td>is the scalar divisor</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a result vector res = v/s </dd></dl>

</div>
</div>
<a id="aa014086872bff2237b6ffa78096b593f" name="aa014086872bff2237b6ffa78096b593f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa014086872bff2237b6ffa78096b593f">&#9670;&#160;</a></span>transpose()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">auto melon::transpose </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; std::vector&lt; T &gt; &gt; &amp;</td>          <td class="paramname"><span class="paramname"><em>m</em></span></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Overloaded operator for vector class allowing to transpose a matrix. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">m</td><td>is the matrix to be transposed</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>returns a result vector res = m^T </dd></dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacemelon.html">melon</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
